{% extends "operators/base.html" %}{% load i18n l10n static %}
{% block title %}{% if form.senior.value %}{% trans "Edit reservation" %}{% else %}{% trans "New reservation" %}{% endif %}{% endblock %}
{% block extrahead %}
<link rel="stylesheet" href="{% static 'leaflet1/leaflet.css' %}" />
<script src="{% static 'leaflet1/leaflet.js' %}"></script>
<link href="{% static 'select2/css/select2.min.css' %}" rel="stylesheet" />
<script src="{% static 'select2/js/select2.min.js' %}"></script>
<script src="{% static 'moment2/moment-with-locales.min.js' %}"></script>
<script src="{% static 'tempus-dominus4/bootstrap-datetimepicker.min.js' %}"></script>
<link rel="stylesheet" href="{% static 'tempus-dominus4/bootstrap-datetimepicker.min.css' %}" />
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.5.0/font/bootstrap-icons.css">
<style>
    .errorlist {
        display: none;
    }
</style>
{% endblock %}
{% block content %}

<div class="page-header">
    <h1 class="display-2 text-dark fw-normal pb-3">{% if form.senior.value %}{% trans "Editing reservation" %}{% else %}{% trans "New reservation" %}{% endif %}</h1>
</div>

<div class="container-fluid">
    <div class="row mt-5">
        <div class="col-sm-12 col-lg-4">
            <p class="h4 fw-normal">{% trans "Choose a senior to start" %} <span class="text-primary">*</span></p>
            <select id="senior-ajax" class="form-control"></select>
            <form action="" method="post" class="mt-3" id="reservation-form">
                {% csrf_token %}
                <div class="h5 fw-normal">
                    {% if form.errors %}
                        <div class="alert alert-danger alert-dismissible fade show mt-3" role="alert">
                            <strong>{% trans 'Errors!' %}</strong> {% trans 'Please check the following fields.' %}
                            <ul class="list-group list-group-flush mt-2">
                                {% for field, errors in form.errors.items %}
                                    {% for error in errors %}
                                        <li class="list-group-item bg-transparent"><strong>&bull;</strong>&nbsp;{{ error }}</li>
                                    {% endfor %}
                                {% endfor %}
                            </ul>
                            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                        </div>
                    {% endif %}
                    {{ form.as_p }}
                </div>
            </form>
        </div>
        <div class="d-none d-lg-block col-lg-8">
            <div id="map" class="h-100"></div>
            <p class="text-end mx-3 my-2"><kbd>Ctrl</kbd>&nbsp;+&nbsp;<kbd>Alt</kbd> {% trans "to navigate the map using the mouse." %}</p>
        </div>
    </div>

    <div class="w-100 my-5 d-none" id="trip-legs-container">
        <div class="pt-1"></div>
        <div class="mt-5 d-flex">
            <h3 class="">{% trans "Trip legs" %}</h3>
            <button role="button" class="btn btn-primary ms-auto" id="add-trip-leg">
                {% trans 'Add trip leg' %} &nbsp;
                <i class="fas fa-plus" aria-hidden="true"></i>
            </button>
        </div>
        <div class="container-fluid">
            <div class="timeline px-1 py-3 w-100 d-flex flex-row flex-nowrap overflow-auto" id="trip-legs-timeline">
            </div>
            <div class="timeline-empty p-5 text-center" id="trip-legs-empty">
                <h2><i class="fas fa-arrows-alt-h" style="color: #757575"></i></h2>
                <p>{% trans 'The timeline is empty.' %}<br/>{% trans 'Add trip legs with the button above.' %}</p>
            </div>
        </div>
    </div>

    <div class="text-end mt-5 w-100">
        <button role="button" type="submit" class="btn btn-lg btn-primary" id="new-reservation-submit"
            form="reservation-form">
            {% trans "Save" %} &nbsp;
            <i class="fas fa-arrow-right" aria-hidden="true"></i>
        </button>
    </div>
</div>

<div class="modal fade" id="new-trip-stage-modal" tabindex="-1">
    <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">{% trans "Edit trip stage" %}</h5>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body">
                <ul class="nav nav-tabs nav-justified" id="new-trip-stage-locations-tabs" role="tablist">
                    <li class="nav-item" role="presentation">
                        <button class="nav-link active" id="new-trip-stage-tab-known-locations" data-bs-toggle="tab"
                            data-bs-target="#new-trip-stage-known-locations" type="button" role="tab"
                            aria-selected="true">
                            <i class="fas fa-location-arrow"></i>
                            &nbsp;<span class="d-none d-md-inline">{% trans "Known location" %}</span>
                        </button>
                    </li>
                    <li class="nav-item" role="presentation">
                        <button class="nav-link" id="new-trip-stage-tab-search-locations" data-bs-toggle="tab"
                            data-bs-target="#new-trip-stage-search-locations" type="button" role="tab"
                            aria-selected="false">
                            <i class="fas fa-search"></i>
                            &nbsp;<span class="d-none d-md-inline">{% trans "Search location" %}</span>
                        </button>
                    </li>
                </ul>
                <div class="tab-content mt-3" id="new-trip-stage-locations-container">
                    <div class="tab-pane show active" id="new-trip-stage-known-locations">
                        <select id="locations-ajax" class="form-control"></select>
                    </div>
                    <div class="tab-pane" id="new-trip-stage-search-locations">
                        <select id="addresses-ajax" class="form-control"></select>
                    </div>
                </div>
                <h6 class="mt-5">{% trans "Expected time" %}</h6>
                <div class="form-group" id="new-trip-stage-time-container">
                    <input type="text" id="new-trip-stage-time" class="form-control">
                </div>
            </div>
            <div class="modal-footer justify-content-between">
                <button type="button" class="btn btn-outline-dark mr-auto" id="new-trip-stage-set-to-home"
                    aria-label="Home address">
                    <i class="fas fa-home" aria-hidden="true"></i>
                    &nbsp;{% trans "Home address" %}
                </button>
                <div>
                    <button class="btn btn-outline-secondary mx-1" type="button" data-bs-dismiss="modal">{% trans "Close" %}</button>
                    <button class="btn btn-success" id="new-trip-stage-submit" type="button">{% trans "Confirm" %}</button>
                </div>
            </div>
        </div>
    </div>
</div>


<div class="modal fade" id="trip-leg-error-modal" tabindex="-1">
    <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">{% trans "Error" %}</h5>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body" id="trip-leg-error-modal-message">
            </div>
            <div class="modal-footer">
                <button class="btn btn-success" data-bs-dismiss="modal" type="button">{% trans "Got it" %}</button>
            </div>
        </div>
    </div>
</div>

<script type="text/javascript">
    function u_atob(ascii) {
        return new TextDecoder().decode(Uint8Array.from(atob(ascii), c => c.charCodeAt(0)));
    }

    $(document).ready(function () {
        $("#id_notes").parent().append($("<a href='#'>Ritorno su chiamata</a>").click(function () {
            let currentValue = $("#id_notes").text();
            if (currentValue) {
                $("#id_notes").text(currentValue + "\nRITORNO SU CHIAMATA");
            } else {
                $("#id_notes").text("RITORNO SU CHIAMATA");
            }
        }));

        var disableMapInteraction = function (map) {
            map.dragging.disable();
            map.touchZoom.disable();
            map.doubleClickZoom.disable();
            map.scrollWheelZoom.disable();
            map.boxZoom.disable();
            map.keyboard.disable();
            if (map.tap) {
                map.tap.disable();
            }
        };

        var enableMapInteraction = function (map) {
            map.dragging.enable();
            map.touchZoom.enable();
            map.doubleClickZoom.enable();
            map.scrollWheelZoom.enable();
            map.boxZoom.enable();
            map.keyboard.enable();
            if (map.tap) {
                map.tap.enable();
            }
        };

        // map configuration
        window.map = L.map('map').setView([46.497523, 11.352499], 13);
        window.layergroup = L.layerGroup().addTo(window.map);
        var tiles = L.tileLayer('//{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
            maxZoom: 18,
            minZoom: 2,
            attribution: '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors'
        }).addTo(window.map);

        // setup map interaction with ctrl+alt key combination
        if (!Modernizr.touchevents) {
            disableMapInteraction(window.map);
            window.map.on('keydown', function (evt) {
                if (evt.originalEvent.ctrlKey && evt.originalEvent.which === 18) {
                    evt.originalEvent.preventDefault();
                    enableMapInteraction(window.map);
                }
            });
            window.map.on('keyup', function (evt) {
                if (evt.originalEvent.which === 18) {
                    evt.originalEvent.preventDefault();
                    disableMapInteraction(window.map);
                }
            });
            document.addEventListener('keydown', function (evt) {
                if (evt.ctrlKey && evt.which === 18) {
                    evt.preventDefault();
                    enableMapInteraction(window.map);
                }
            });
            document.addEventListener('keyup', function (evt) {
                if (evt.which === 18) {
                    evt.preventDefault();
                    disableMapInteraction(window.map);
                }
            });
        } else {
            $('#map-navigation-keys-hint').hide();
        }

        // trip stages initialization
        window.tripLegs = [];
        window.generateTripStage = function (el, index, estimatedTime) {
            return {
                location: {
                    pk: el.pk || null,
                    name: el.name,
                    address: el.text,
                    address_parts: el.address,
                    lat: el.lat,
                    lng: el.lon || el.lng
                },
                number: index,
                estimatedTime: estimatedTime
            };
            // window.addMarker(index, el.lat, el.lon);
        };

        window.checkForIncompleteTripLegs = function () {
            return Object.values(window.tripLegs).some(t => t.startStage == null || t.startStage == {} || 
                t.endStage == null || t.endStage == {}) || Object.keys(window.tripLegs).length != $('.timeline .card').length;
        }

        window.checkForOverlappingTripLegs = function() {
            for (var tripLeg in window.tripLegs) {
                for (var otherTripLeg in window.tripLegs) {
                    if (otherTripLeg == tripLeg) {
                        continue;
                    }
                    if (tripLeg.start.estimated_be_at > otherTripLeg.start.estimated_be_at && tripLeg.start.estimated_be_at < otherTripLeg.end.estimated_be_at) {
                        return true;
                    }
                    if (otherTripLeg.end.estimated_be_at > tripLeg.start.estimated_be_at && otherTripLeg.end.estimated_be_at < tripLeg.end.estimated_be_at) {
                        return true;
                    }
                    return false;
                }
            }
        }

        window.checkForMissingTripLegs = function() {
            return Object.keys(window.tripLegs).length == 0;
        }

        window.joinReservationDateAndTripLegTime = function (time) {
            let date = moment($('#id_reservation_date').val());
            time.set({
                day: date.day(),
                month: date.month(),
                year: date.year()
            })
            return time;
        }

        window.commitTripLegs = function() {
            var trip_legs = []
            for (var tripLegId of Object.keys(window.tripLegs)) {
                if (!window.tripLegs[tripLegId] || 
                    !window.tripLegs[tripLegId].startStage || 
                        !window.tripLegs[tripLegId].endStage) {
                    continue;
                }
                var { estimatedTime, ...start_stage } = 
                    window.tripLegs[tripLegId].startStage;
                var estimatedStartTime = estimatedTime.format('HH:mm');

                var { estimatedTime, ...end_stage } = 
                    window.tripLegs[tripLegId].endStage;
                var estimatedEndTime = estimatedTime.format('HH:mm');

                trip_legs.push({
                    start: {
                        estimated_be_at: estimatedStartTime,
                        ...start_stage
                    },
                    end: {
                        estimated_be_at: estimatedEndTime,
                        ...end_stage
                    }
                });
            }
            $('#id_trip_legs').val(JSON.stringify(trip_legs));
        }

        // marker creation
        window.addMarker = function (index, lat, lng) {
            var greenMarker = new L.icon({
                iconUrl: "{% static 'leaflet1/images/marker-icon-2x-green.png' %}",
                shadowUrl: "{% static 'leaflet1/images/marker-shadow.png' %}",
                iconSize: [25, 41],
                iconAnchor: [12, 41],
                popupAnchor: [1, -34],
                shadowSize: [41, 41]
            });
            L.marker([parseFloat(lat), parseFloat(lng)], {
                icon: greenMarker
            }).addTo(window.layergroup);
        }

        window.updateSenior = function (senior) {
            window.senior = senior;
            window.layergroup.clearLayers();
            window.addMarker(1, window.senior.home.lat, window.senior.home.lng);
            $("#id_senior").val(window.senior.id);
            $('#trip-legs-container').removeClass('d-none');
        };

        // senior search
        $('#senior-ajax').select2({
            ajax: {
                url: "{% url 'operators:senior-ajax-query' %}",
                type: "POST",
                dataType: "json",
                delay: 150,
                data: function (params) { return { "q": params.term, "csrfmiddlewaretoken": "{{ csrf_token }}" }; },
                processResults: function (data, params) { return { results: data } }
            },
            placeholder: "{% trans 'Start typing the card no. or the last name' %}",
            minimumInputLength: 2,
            templateResult: function (senior) {
                if (senior.fullname == undefined) return $("");
                var out = $(
                    "<div class=''><h4><span class='h4 fw-normal'><i class='fas fa-user'></i>&nbsp;" + senior.fullname +
                    "</span></h4><span class='h5 fw-normal'><i class='fas fa-id-card'></i>&nbsp;" + (senior.member_card_issuer || "{% trans 'not registered' %}") + " " +
                    (senior.member_card_number || "") + "<br/><i class='fas fa-phone'></i>&nbsp;" +
                    (senior.phone_number || "{% trans 'not registered' %}") + "&nbsp;<br/><i class='fas fa-envelope'></i>&nbsp;" +
                    (senior.email || "{% trans 'not registered' %}") + "<br><i class='fas fa-map-marked-alt'></i>&nbsp;" +
                    senior.home.address + "</span></div>"
                );
                return out;
            },
            templateSelection: function (senior) {
                return !!senior.fullname ? $("<span class='h5 fw-normal'>"
                    + senior.fullname + "</span>") : senior.text;
            },
            width: '100%'
        });
        $("#senior-ajax").on("select2:select", function (e) {
            window.updateSenior(e.params.data);
        });

        $("#addresses-ajax").select2({
            ajax: {
                url: "{% url 'addresses-ajax-search' %}",
                type: "POST",
                dataType: "json",
                delay: 150,
                data: function (params) { return { "q": params.term, "csrfmiddlewaretoken": "{{ csrf_token }}" }; },
                processResults: function (data, params) { return { results: data } }
            },
            placeholder: "{% trans 'Start typing the address' %}",
            minimumInputLength: 6,
            templateResult: function (address) {
                if (address.text == undefined) return $("");
                var out = $(
                    "<div class='select2-result'>" +
                    "<h4>" +
                    "<b><i class='bi bi-geo-alt'></i>" +
                    "&nbsp;" + address.text +
                    "</b>" +
                    "</h4>" +
                    "</div>"
                );
                return out;
            },
            templateSelection: function (address) {
                return address.id || address.text;
            },
            dropdownParent: $('#new-trip-stage-modal .modal-content'),
            width: '100%'
        });

        $("#locations-ajax").select2({
            ajax: {
                url: "{% url 'locations-ajax-list' %}",
                type: "POST",
                dataType: "json",
                delay: 150,
                data: function (params) { return { "q": params.term, "csrfmiddlewaretoken": "{{ csrf_token }}" }; },
                processResults: function (data, params) { return { results: data } }
            },
            placeholder: "{% trans 'Start typing the name of the location' %}",
            minimumInputLength: 3,
            templateResult: function (location) {
                if (location.text == undefined) return $("");
                var out = $(
                    "<div class='select2-result'>" +
                    "<h4>" +
                    "<b><i class='bi bi-geo-alt'></i>" +
                    "&nbsp;" + location.text +
                    "</b>" +
                    "</h4>" +
                    "</div>"
                );
                return out;
            },
            templateSelection: function (location) {
                return location.text;
            },
            dropdownParent: $('#new-trip-stage-modal .modal-content'),
            width: '100%'
        });

        window.setStartStageForTripLeg = function (card, tripLeg, address, estimatedTime) {
            if (tripLeg.endStage) {
                if (joinReservationDateAndTripLegTime(tripLeg.endStage.estimatedTime).isBefore(joinReservationDateAndTripLegTime(estimatedTime))) {
                    $('#trip-leg-error-modal-message').text("{% trans 'Please make sure departure time is earlier than arrival time.' %}");
                    $('#trip-leg-error-modal').modal('show');
                    return;
                }
            }
            card.find('.trip-leg-start-time').text(
                `${String(estimatedTime.hours()).padStart(2, '0')}:${String(estimatedTime.minutes()).padStart(2, '0')}`
            );
            card.find('.trip-leg-start-location').html(address.text);
            card.find('.trip-leg-start .trip-leg-unset').addClass('d-none');
            card.find('.trip-leg-start .trip-leg-set').removeClass('d-none');
            tripLeg.startStage = window.generateTripStage(
                address, 0, estimatedTime
            );
        };

        window.setEndStageForTripLeg = function (card, tripLeg, address, estimatedTime) {
            if (tripLeg.startStage) {
                if (joinReservationDateAndTripLegTime(tripLeg.startStage.estimatedTime).isAfter(joinReservationDateAndTripLegTime(estimatedTime))) {
                    $('#trip-leg-error-modal-message').text("{% trans 'Please make sure departure time is earlier than arrival time.' %}");
                    $('#trip-leg-error-modal').modal('show');
                    return;
                }
            }
            card.find('.trip-leg-end-time').text(
                `${String(estimatedTime.hours()).padStart(2, '0')}:${String(estimatedTime.minutes()).padStart(2, '0')}`
            );
            card.find('.trip-leg-end-location').html(address.text);
            card.find('.trip-leg-end .trip-leg-unset').addClass('d-none');
            card.find('.trip-leg-end .trip-leg-set').removeClass('d-none');
            tripLeg.endStage = window.generateTripStage(
                address, 1, estimatedTime
            );
        }

        $('#new-trip-stage-submit').on('click', function (evt) {
            if ($('#new-trip-stage-tab-known-locations').hasClass('active')) {
                var address = $('#locations-ajax').select2('data')[0];
            } else {
                var address = $('#addresses-ajax').select2('data')[0];
            }
            
            var estimatedTimeVal = $('#new-trip-stage-time').val().split(":");
            var estimatedTime = moment().hours(estimatedTimeVal[0]).minutes(estimatedTimeVal[1]);

            var card = $(window.currentTripLeg.el);
            var tripLeg = window.tripLegs[card.attr('id')] || {};
            if (window.currentTripLeg.point === 'departure') {
                window.setStartStageForTripLeg(card, tripLeg, address, estimatedTime);
            } else if (window.currentTripLeg.point === 'arrival') {
                window.setEndStageForTripLeg(card, tripLeg, address, estimatedTime);
            }
            $('#new-trip-stage-modal').modal('hide');

            window.tripLegs[card.attr('id')] = tripLeg;
            window.commitTripLegs();
        });

        $('#new-reservation-submit').on('click', function (evt) {
            if (window.checkForMissingTripLegs()) {
                evt.preventDefault();
                $('#trip-leg-error-modal-message').text("{% trans 'Please insert at least one trip leg in order to create a reservation.' %}");
                $('#trip-leg-error-modal').modal('show');
                return;
            }
            if (window.checkForIncompleteTripLegs()) {
                evt.preventDefault();
                $('#trip-leg-error-modal-message').text("{% trans 'Please make sure all trip legs are valid, i.e. complete with departure and arrival stages.' %}");
                $('#trip-leg-error-modal').modal('show');
                return;
            }
            if (window.checkForOverlappingTripLegs()) {
                evt.preventDefault();
                $('#trip-leg-error-modal-message').text("{% trans 'There are overlapping trip legs. Please make sure each leg terminates before another one begins.' %}");
                $('#trip-leg-error-modal').modal('show');
                return;
            }
        })

        $('#new-trip-stage-time').datetimepicker({
            format: 'HH:mm',
            collapse: false,
            icons: {
                date: "bi bi-calendar",
                up: "bi bi-chevron-up",
                down: "bi bi-chevron-down",
                previous: "bi bi-chevron-left",
                next: "bi bi-chevron-right",
                today: "bi bi-calendar-check",
                clear: "bi bi-calendar-x"
            }
        });

        $('#new-trip-stage-set-to-home').on('click', function () {
            if (window.senior.home.name) {
                $('#new-trip-stage-tab-known-locations').trigger('click');
                $('#locations-ajax option').empty();
                $('#locations-ajax').select2("trigger", "select", {
                    data: {
                        id: window.senior.home.name,
                        text: window.senior.home.name, 
                        ...window.senior.home
                    }
                });
            } else {
                $('#new-trip-stage-tab-search-locations').trigger('click');
                $('#addresses-ajax option').empty();
                $('#addresses-ajax').select2("trigger", "select", {
                    data: {
                        id: window.senior.home.address, 
                        text: window.senior.home.address, 
                        ...window.senior.home
                    }
                });
            }
        });

        window.addTripLeg = function (startStage, endStage) {
            var findCardIndex = function (evt) {
                return $('.timeline .card-wrapper').index(
                    $(evt.target).parents('.card-wrapper')
                );
            }

            var guidGenerator = function () {
                var S4 = function () {
                    return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
                };
                return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
            }

            var el = $(`<div class="card-wrapper col-md-4 m-md-0 col-12 m-2">
                <div class="card mx-auto" style="width: 18rem;">
                    <div class="card-body p-0">
                        <div class="d-flex justify-content-between align-items-center">
                            <h5 class="card-title p-3">{% trans 'Trip leg' %}</h5>
                            <button role="button" class="circle-btn me-3" data-bs-toggle="dropdown" data-bs-target="#trip-leg-card-menu">
                                <span class="p-1"><i class="fas fa-ellipsis-v" style="color: #757575"></i></span>
                            </button>
                            <ul class="dropdown-menu" id="trip-leg-card-menu">
                                <li><a class="dropdown-item trip-leg-delete">{% trans 'Delete' %}</a></li>
                                <li><a class="dropdown-item trip-leg-duplicate">{% trans 'Duplicate' %}</a></li>
                                <li><a class="dropdown-item trip-leg-invert">{% trans 'Invert' %}</a></li>
                            </ul>
                        </div>
                        <div class="p-3 trip-leg-stages">
                            <div class="trip-leg-start">
                                <div class="p-1 trip-leg-set d-none">
                                    <strong class="trip-leg-start-time">-</strong>&nbsp;&bull;&nbsp;<span class="trip-leg-start-location">{% trans 'Departure point not set' %}</span>
                                </div>
                                <div class="p-2 trip-leg-unset text-center">
                                    <h2><i class="fas fa-map-marker-alt" style="color: #757575"></i></h2>
                                    <p>{% trans 'Departure point not set' %}</p>
                                </div>
                            </div>
                            <p class="text-center pt-3">&darr;</p>
                            <div class="trip-leg-end">
                                <div class="p-1 trip-leg-set d-none">
                                    <strong class="trip-leg-end-time">-</strong>&nbsp;&bull;&nbsp;<span class="trip-leg-end-location">{% trans 'Arrival point not set' %}</span>
                                </div>
                                <div class="p-2 trip-leg-unset text-center">
                                    <h2><i class="fas fa-map-marker-alt" style="color: #757575"></i></h2>
                                    <p>{% trans 'Arrival point not set' %}</p>
                                </div>
                            </div>
                        </div>
                        <a type="button" data-bs-toggle="modal" data-bs-target="#new-trip-stage-modal"
                            id="trip-leg-set-departure"
                            class="list-group-item list-group-item-action list-group-item-secondary text-center">{% trans "Set departure location" %}</a>
                        <a type="button" data-bs-toggle="modal" data-bs-target="#new-trip-stage-modal"
                            id="trip-leg-set-arrival"
                            class="list-group-item list-group-item-action list-group-item-secondary text-center">{% trans "Set arrival location" %}</a>
                    </div>
                </div>
            </div>`);

            $(el).attr('id', guidGenerator());
            $(el).find('#trip-leg-set-departure').on('click', function (evt) {
                window.currentTripLeg = {
                    index: findCardIndex(evt),
                    point: 'departure',
                    el: el
                };
                var id = el.attr('id');
                if (window.tripLegs[id] && window.tripLegs[id].startStage) {
                    $('#new-trip-stage-time').val(
                        window.tripLegs[id].startStage.estimatedTime.format('HH:mm')
                    );
                    if (window.tripLegs[id].startStage.location.name) {
                        $('#new-trip-stage-tab-known-locations').trigger('click');
                        $('#locations-ajax option').empty();
                        $("#locations-ajax").select2("trigger", "select", {
                            data: {
                                id: window.tripLegs[id].startStage.location.name, 
                                text: window.tripLegs[id].startStage.location.name,
                                ...window.tripLegs[id].startStage.location
                            }
                        });
                    } else {
                        $('#new-trip-stage-tab-search-locations').trigger('click');
                        $('#addresses-ajax option').empty();
                        $("#addresses-ajax").select2("trigger", "select", {
                            data: {
                                id: window.tripLegs[id].startStage.location.address, 
                                text: window.tripLegs[id].startStage.location.address, 
                                ...window.tripLegs[id].startStage.location
                            }
                        });
                    }
                } else {
                    $('#new-trip-stage-time').val(
                        moment().format('HH:mm')
                    );
                }
            });
            $(el).find('#trip-leg-set-arrival').on('click', function (evt) {
                window.currentTripLeg = {
                    index: findCardIndex(evt),
                    point: 'arrival',
                    el: el
                };
                var id = el.attr('id');
                if (window.tripLegs[id] && window.tripLegs[id].endStage) {
                    $('#new-trip-stage-time').val(
                        window.tripLegs[id].endStage.estimatedTime.format('HH:mm')
                    );
                    if (window.tripLegs[id].endStage.location.name) {
                        $('#new-trip-stage-tab-known-locations').trigger('click');
                        $('#locations-ajax option').empty();
                        $("#locations-ajax").select2("trigger", "select", {
                            data: {
                                id: window.tripLegs[id].endStage.location.name, 
                                text: window.tripLegs[id].endStage.location.name, 
                                ...window.tripLegs[id].endStage.location
                            }
                        });
                    } else {
                        $('#new-trip-stage-tab-search-locations').trigger('click');
                        $('#addresses-ajax option').empty();
                        $("#addresses-ajax").select2("trigger", "select", {
                            data: {
                                id: window.tripLegs[id].endStage.location.address, 
                                text: window.tripLegs[id].endStage.location.address, 
                                ...window.tripLegs[id].endStage.location
                            }
                        });
                    }
                }
                else if (window.tripLegs[id] && window.tripLegs[id].startStage) {
                    $('#new-trip-stage-time').val(
                        moment(window.tripLegs[id].startStage.estimatedTime).add("30", "minutes").format('HH:mm')
                    );
                }
                else {
                    $('#new-trip-stage-time').val(
                        moment().format('HH:mm')
                    );
                }
            });
            $(el).find('.trip-leg-delete').on('click', function (evt) {
                var id = el.attr('id');
                $(`#${id}`).remove();
                delete window.tripLegs[id];
                window.commitTripLegs();
                if (Object.keys(window.tripLegs).length < 1 && $('.timeline .card').length == 0) {
                    $('#trip-legs-empty').removeClass('d-none');
                }
            });
            $(el).find('.trip-leg-duplicate').on('click', function(evt) {
                var id = el.attr('id');
                var tripLeg = window.tripLegs[id];
                if (!tripLeg || !tripLeg.startStage || !tripLeg.endStage) {
                    return;
                }
                window.addTripLeg({
                    pk: tripLeg.startStage.location.pk,
                    name: tripLeg.startStage.location.name,
                    text: tripLeg.startStage.location.address,
                    lat: tripLeg.startStage.location.lat,
                    lon: tripLeg.startStage.location.lng,
                    estimatedTime: tripLeg.startStage.estimatedTime
                }, {
                    pk: tripLeg.endStage.location.pk,
                    name: tripLeg.endStage.location.name,
                    text: tripLeg.endStage.location.address,
                    lat: tripLeg.endStage.location.lat,
                    lon: tripLeg.endStage.location.lng,
                    estimatedTime: tripLeg.endStage.estimatedTime
                });
            });
            $(el).find('.trip-leg-invert').on('click', function(evt) {
                var id = el.attr('id');
                var tripLeg = window.tripLegs[id];
                if (!tripLeg || !tripLeg.startStage || !tripLeg.endStage) {
                    return;
                }
                window.addTripLeg({
                    pk: tripLeg.endStage.location.pk,
                    name: tripLeg.endStage.location.name,
                    text: tripLeg.endStage.location.address,
                    lat: tripLeg.endStage.location.lat,
                    lon: tripLeg.endStage.location.lng,
                    estimatedTime: tripLeg.startStage.estimatedTime
                }, {
                    pk: tripLeg.startStage.location.pk,
                    name: tripLeg.startStage.location.name,
                    text: tripLeg.startStage.location.address,
                    lat: tripLeg.startStage.location.lat,
                    lon: tripLeg.startStage.location.lng,
                    estimatedTime: tripLeg.endStage.estimatedTime
                });
            })

            if (startStage != null && endStage != null) {
                window.currentTripLeg = {
                    index: $('.timeline .card-wrapper').index(
                        $(el).parents('.card-wrapper')
                    ),
                    point: 'departure',
                    el: el
                };
                var tripLeg = window.tripLegs[el.attr('id')] || {};
                window.setStartStageForTripLeg(
                    el, tripLeg, startStage, startStage.estimatedTime);

                window.currentTripLeg = {
                    index: $('.timeline .card-wrapper').index(
                        $(el).parents('.card-wrapper')
                    ),
                    point: 'arrival',
                    el: el
                };
                window.setEndStageForTripLeg(
                    el, tripLeg, endStage, endStage.estimatedTime);
                
                window.tripLegs[el.attr('id')] = tripLeg;
                window.commitTripLegs();
            }

            $('#trip-legs-empty').addClass('d-none');
            $('#trip-legs-timeline').append(el);
        }

        $('#add-trip-leg').on('click', function () {
            if ($("#id_reservation_date").val() === "") {
                alert("{%  trans 'Choose the day first!' %}");
                return;
            }
            window.addTripLeg(null, null);
        });



        /**********************************************/
        /* Fill in data from existing instance (edit) */
        /**********************************************/

        {% if form.instance.senior %}
        $("#senior-ajax").append(new Option(
            $('<div/>').html("{{ form.instance.senior.user.get_full_name }}").text(),
            $('<div/>').html("{{ form.instance.senior.user.get_full_name }}").text(),
            true,
            true
        ));
        window.updateSenior({
            id: {{ form.instance.senior.id }},
            home: {
                pk: {{ form.instance.senior.home_address.pk }},
                {% if form.instance.senior.home_address.name %}
                name: "{{ form.instance.senior.home_address.name }}",
                {% else %}
                name: null,
                {% endif %}
                address: u_atob("{{ form.instance.senior.home_address.get_b64_print_address }}"),
                lat: {{ form.instance.senior.home_address.lat|unlocalize }},
                lng: {{ form.instance.senior.home_address.lng|unlocalize }},
                {% if form.instance.senior.home_address.address_parts %}
                address_parts: {{ form.instance.senior.home_address.address_parts|safe }}
                {% else %}
                address_parts: null
                {% endif %}
            }
        });
        $('#id_reservation_date').val('{{ form.instance.first_stage_time|date:"Y-m-d" }}')
        {% endif %}

        {% if form.instance.get_trip_legs %}
        {% for tripleg in form.instance.get_trip_legs %}
        console.log("{{ tripleg.start.location.get_b64_print_address }}");
        window.addTripLeg({
            pk: {{ tripleg.start.location.pk }},
            {% if tripleg.start.location.name %}
            name: "{{ tripleg.start.location.name }}",
            text: "{{ tripleg.start.location.name }}",
            {% else %}
            name: null,
            text: u_atob("{{ tripleg.start.location.get_b64_print_address }}"),
            {% endif %}
            address: u_atob("{{ tripleg.start.location.get_b64_print_address }}"),
            lat: {{ tripleg.start.location.lat|unlocalize }},
            lon: {{ tripleg.start.location.lng|unlocalize }},
            estimatedTime: moment('{{ tripleg.start.estimated_be_at|date:"c" }}')
        }, {
            pk: {{ tripleg.end.location.pk }},
            {% if tripleg.end.location.name %}
            name: "{{ tripleg.end.location.name }}",
            text: "{{ tripleg.end.location.name }}",
            {% else %}
            name: null,
            text: u_atob("{{ tripleg.end.location.get_b64_print_address }}"),
            {% endif %}
            address: u_atob("{{ tripleg.end.location.get_b64_print_address }}"),
            lat: {{ tripleg.end.location.lat|unlocalize }},
            lon: {{ tripleg.end.location.lng|unlocalize }},
            estimatedTime: moment('{{ tripleg.end.estimated_be_at|date:"c" }}')
        });
        {% endfor %}
        {% endif %}

        
        /*************************************************/
        /* Fill in data from source instance (replicate) */
        /*************************************************/

        {% if source.senior %}
        $("#senior-ajax").append(new Option(
            $('<div/>').html("{{ source.senior.user.get_full_name }}").text(),
            $('<div/>').html("{{ source.senior.user.get_full_name }}").text(),
            true,
            true
        ));
        window.updateSenior({
            id: {{ source.senior.id }},
            home: {
                pk: {{ source.senior.home_address.pk }},
                {% if source.senior.home_address.name %}
                name: "{{ source.senior.home_address.name }}",
                {% else %}
                name: null,
                {% endif %}
                address: u_atob("{{ source.senior.home_address.get_b64_print_address }}"),
                lat: {{ source.senior.home_address.lat|unlocalize }},
                lng: {{ source.senior.home_address.lng|unlocalize }},
                {% if source.senior.home_address.address_parts %}
                address_parts: {{ source.senior.home_address.address_parts|safe }}
                {% else %}
                address_parts: null
                {% endif %}
            }
        });
        $('#id_reservation_date').val('{{ source.first_stage_time|date:"Y-m-d" }}');
        $('#id_notes').val(atob('{{ source.get_b64_notes }}'));
        {% endif %}

        {% if source.get_trip_legs %}
        {% for tripleg in source.get_trip_legs %}
        window.addTripLeg({
            pk: {{ tripleg.start.location.pk }},
            {% if tripleg.start.location.name %}
            name: "{{ tripleg.start.location.name }}",
            text: "{{ tripleg.start.location.name }}",
            {% else %}
            name: null,
            text: u_atob("{{ tripleg.start.location.get_b64_print_address }}"),
            {% endif %}
            lat: {{ tripleg.start.location.lat|unlocalize }},
            lon: {{ tripleg.start.location.lng|unlocalize }},
            estimatedTime: moment('{{ tripleg.start.estimated_be_at|date:"c" }}')
        }, {
            pk: {{ tripleg.end.location.pk }},
            {% if tripleg.end.location.name %}
            name: "{{ tripleg.end.location.name }}",
            text: "{{ tripleg.end.location.name }}",
            {% else %}
            name: null,
            text: u_atob("{{ tripleg.end.location.get_b64_print_address }}"),
            {% endif %}
            lat: {{ tripleg.end.location.lat|unlocalize }},
            lon: {{ tripleg.end.location.lng|unlocalize }},
            estimatedTime: moment('{{ tripleg.end.estimated_be_at|date:"c" }}')
        });
        {% endfor %}
        {% endif %}
    });
</script>
<script src="{% static 'modernizr3-touchevents/touchevents.js' %}"></script>

{% endblock %}